blob: 8fb2adf445a4a7e92904b9a1031671bdbcb393f6 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
114relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700130pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800131multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000132android_root="/system"
Alex Light10bc5a42016-05-10 10:01:22 -0700133# By default we will use optimizing.
134image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000135image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700136
137while true; do
138 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700140 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100141 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700142 shift
Alex Light91de25f2015-10-28 17:00:06 -0700143 elif [ "x$1" = "x--quiet" ]; then
144 quiet="yes"
145 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700146 elif [ "x$1" = "x--use-java-home" ]; then
147 if [ -n "${JAVA_HOME}" ]; then
148 export JAVA="${JAVA_HOME}/bin/java"
149 export JAVAC="${JAVA_HOME}/bin/javac -g"
150 else
151 echo "Passed --use-java-home without JAVA_HOME variable set!"
152 usage="yes"
153 fi
154 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800155 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700156 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800157 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700158 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700159 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700160 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100161 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100162 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700163 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700164 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800165 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700166 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700167 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700168 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700169 shift
170 elif [ "x$1" = "x--dalvik" ]; then
171 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800172 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700173 shift
Alex Light03a112d2014-08-25 13:25:56 -0700174 elif [ "x$1" = "x--no-dex2oat" ]; then
175 have_dex2oat="no"
176 shift
177 elif [ "x$1" = "x--no-patchoat" ]; then
178 have_patchoat="no"
179 shift
180 elif [ "x$1" = "x--no-image" ]; then
181 have_image="no"
182 shift
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000183 elif [ "x$1" = "x--npic-image" ]; then
184 pic_image_suffix="-npic"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700185 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800186 elif [ "x$1" = "x--multi-image" ]; then
187 multi_image_suffix="-multi"
188 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700189 elif [ "x$1" = "x--pic-test" ]; then
190 run_args="${run_args} --pic-test"
191 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700192 elif [ "x$1" = "x--relocate" ]; then
193 relocate="yes"
194 shift
195 elif [ "x$1" = "x--no-relocate" ]; then
196 relocate="no"
197 shift
198 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100199 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700200 prebuild_mode="yes"
201 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700202 elif [ "x$1" = "x--strip-dex" ]; then
203 run_args="${run_args} --strip-dex"
204 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000205 elif [ "x$1" = "x--debuggable" ]; then
206 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000207 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000208 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700209 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100210 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700211 prebuild_mode="no"
212 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700213 elif [ "x$1" = "x--gcverify" ]; then
214 basic_verify="true"
215 gc_verify="true"
216 shift
217 elif [ "x$1" = "x--gcstress" ]; then
218 basic_verify="true"
219 gc_stress="true"
220 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700221 elif [ "x$1" = "x--image" ]; then
222 shift
223 image="$1"
224 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700225 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000226 elif [ "x$1" = "x-Xcompiler-option" ]; then
227 shift
228 option="$1"
229 run_args="${run_args} -Xcompiler-option $option"
230 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700231 elif [ "x$1" = "x--runtime-option" ]; then
232 shift
233 option="$1"
234 run_args="${run_args} --runtime-option $option"
235 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700236 elif [ "x$1" = "x--gdb-arg" ]; then
237 shift
238 gdb_arg="$1"
239 run_args="${run_args} --gdb-arg $gdb_arg"
240 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700241 elif [ "x$1" = "x--debug" ]; then
242 run_args="${run_args} --debug"
243 shift
244 elif [ "x$1" = "x--gdb" ]; then
245 run_args="${run_args} --gdb"
246 dev_mode="yes"
247 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700248 elif [ "x$1" = "x--strace" ]; then
249 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700250 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700251 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700252 elif [ "x$1" = "x--zygote" ]; then
253 run_args="${run_args} --zygote"
254 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800255 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000256 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700257 image_suffix="-interpreter"
258 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800259 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700260 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000261 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800262 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700263 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700264 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800265 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700266 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700267 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700268 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700269 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700270 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700271 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700272 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700273 elif [ "x$1" = "x--no-optimize" ]; then
274 run_args="${run_args} --no-optimize"
275 shift
276 elif [ "x$1" = "x--no-precise" ]; then
277 run_args="${run_args} --no-precise"
278 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700279 elif [ "x$1" = "x--invoke-with" ]; then
280 shift
281 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700282 if [ "x$what" = "x" ]; then
283 echo "$0 missing argument to --invoke-with" 1>&2
284 usage="yes"
285 break
286 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700287 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700288 shift
289 elif [ "x$1" = "x--dev" ]; then
290 run_args="${run_args} --dev"
291 dev_mode="yes"
292 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700293 elif [ "x$1" = "x--build-only" ]; then
294 build_only="yes"
295 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100296 elif [ "x$1" = "x--build-with-javac-dx" ]; then
297 USE_JACK="false"
298 shift
299 elif [ "x$1" = "x--build-with-jack" ]; then
300 USE_JACK="true"
301 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700302 elif [ "x$1" = "x--output-path" ]; then
303 shift
304 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700305 if [ "x$tmp_dir" = "x" ]; then
306 echo "$0 missing argument to --output-path" 1>&2
307 usage="yes"
308 break
309 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700310 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000311 elif [ "x$1" = "x--android-root" ]; then
312 shift
313 if [ "x$1" = "x" ]; then
314 echo "$0 missing argument to --android-root" 1>&2
315 usage="yes"
316 break
317 fi
318 android_root="$1"
319 run_args="${run_args} --android-root $1"
320 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700321 elif [ "x$1" = "x--update" ]; then
322 update_mode="yes"
323 shift
324 elif [ "x$1" = "x--help" ]; then
325 usage="yes"
326 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700327 elif [ "x$1" = "x--64" ]; then
328 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700329 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700330 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200331 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700332 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200333 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700334 elif [ "x$1" = "x--stream" ]; then
335 trace_stream="true"
336 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700337 elif [ "x$1" = "x--always-clean" ]; then
338 always_clean="yes"
339 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700340 elif [ "x$1" = "x--never-clean" ]; then
341 never_clean="yes"
342 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800343 elif [ "x$1" = "x--dex2oat-swap" ]; then
344 run_args="${run_args} --dex2oat-swap"
345 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700346 elif [ "x$1" = "x--instruction-set-features" ]; then
347 shift
348 run_args="${run_args} --instruction-set-features $1"
349 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700350 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700351 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700352 usage="yes"
353 break
354 else
355 break
356 fi
357done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700358
Alex Light10bc5a42016-05-10 10:01:22 -0700359run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700360# Allocate file descriptor real_stderr and redirect it to the shell's error
361# output (fd 2).
362if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
363 exec {real_stderr}>&2
364else
365 # In bash before version 4.1 we need to do a manual search for free file
366 # descriptors.
367 FD=3
368 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
369 real_stderr=$FD
370 eval "exec ${real_stderr}>&2"
371fi
372if [ "$quiet" = "yes" ]; then
373 # Force the default standard output and error to go to /dev/null so we will
374 # not print them.
375 exec 1>/dev/null
376 exec 2>/dev/null
377fi
378
379function err_echo() {
380 echo "$@" 1>&${real_stderr}
381}
382
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700383# tmp_dir may be relative, resolve.
384#
385# Cannot use realpath, as it does not exist on Mac.
386# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700387# Cannot use readlink -m, as it does not exist on Mac.
388# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700389noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700390tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700391mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700392
Alex Lighte7873ec2014-08-12 09:53:50 -0700393if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800394 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
395 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700396fi
397if [ "$gc_verify" = "true" ]; then
398 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
399fi
400if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700401 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700402fi
Jeff Hao85139a32014-07-23 11:52:52 -0700403if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700404 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
405 if [ "$trace_stream" = "true" ]; then
406 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
407 # the ability to analyze the file and just write to /dev/null.
408 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
409 # Enable streaming mode.
410 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
411 else
412 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
413 fi
414elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700415 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700416 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700417fi
418
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700419# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100420# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100421function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100422 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800423 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700424 if [ "x${suffix64}" = "x64" ]; then
425 target_arch_name=${grep64bit}
426 else
427 target_arch_name=${grep32bit}
428 fi
429}
430
David Brazdil853a4c32015-09-28 16:15:50 +0100431function guess_host_arch_name() {
432 if [ "x${suffix64}" = "x64" ]; then
433 host_arch_name="x86_64"
434 else
435 host_arch_name="x86"
436 fi
437}
438
Alex Lighta59dd802014-07-02 16:28:08 -0700439if [ "$target_mode" = "no" ]; then
440 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700441 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700442 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700443 exit 1;
444 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700445 fi
446fi
447
Alex Light03a112d2014-08-25 13:25:56 -0700448if [ "$have_patchoat" = "no" ]; then
449 run_args="${run_args} --no-patchoat"
450fi
451
452if [ "$have_dex2oat" = "no" ]; then
453 run_args="${run_args} --no-dex2oat"
454fi
455
Jeff Hao201803f2013-11-20 18:11:39 -0800456if [ ! "$runtime" = "jvm" ]; then
457 run_args="${run_args} --lib $lib"
458fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700459
Jeff Hao201803f2013-11-20 18:11:39 -0800460if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700461 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100462 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800463 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700464 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700465 else
466 true # defaults to using target BOOTCLASSPATH
467 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800468elif [ "$runtime" = "art" ]; then
469 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100470 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800471 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700472 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800473 else
David Brazdil853a4c32015-09-28 16:15:50 +0100474 guess_target_arch_name
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700475 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}:/system/lib${suffix64}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800476 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800477 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700478 if [ "$relocate" = "yes" ]; then
479 run_args="${run_args} --relocate"
480 else
481 run_args="${run_args} --no-relocate"
482 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700483elif [ "$runtime" = "jvm" ]; then
484 # TODO: Detect whether the host is 32-bit or 64-bit.
485 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700486fi
487
Alex Light03a112d2014-08-25 13:25:56 -0700488if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700489 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700490 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700491 exit 1
492 fi
493 if [ "$target_mode" = "no" ]; then
494 framework="${ANDROID_HOST_OUT}/framework"
495 bpath_suffix="-hostdex"
496 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000497 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700498 bpath_suffix=""
499 fi
500 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
501 # fail since these jar files will be stripped.
502 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000503 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700504 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
505 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700506 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
507 # Pass down the bootclasspath
508 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700509 run_args="${run_args} --no-image"
510fi
511
jeffhao5d1ac922011-09-29 17:41:15 -0700512if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700513 err_echo "--dev and --update are mutually exclusive"
514 usage="yes"
515fi
516
517if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
518 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700519 usage="yes"
520fi
521
522if [ "$usage" = "no" ]; then
523 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
524 test_dir=`basename "$oldwd"`
525 else
526 test_dir="$1"
527 fi
528
529 if [ '!' -d "$test_dir" ]; then
530 td2=`echo ${test_dir}-*`
531 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700532 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700533 usage="yes"
534 fi
535 test_dir="$td2"
536 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700537 # Shift to get rid of the test name argument. The rest of the arguments
538 # will get passed to the test run.
539 shift
540fi
541
542if [ "$usage" = "yes" ]; then
543 prog=`basename $prog`
544 (
545 echo "usage:"
546 echo " $prog --help Print this message."
547 echo " $prog [options] [test-name] Run test normally."
548 echo " $prog --dev [options] [test-name] Development mode" \
549 "(dumps to stdout)."
550 echo " $prog --update [options] [test-name] Update mode" \
551 "(replaces expected.txt)."
552 echo ' Omitting the test name or specifying "-" will use the' \
553 "current directory."
554 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000555 echo " -O Run non-debug rather than debug build (off by default)."
556 echo " -Xcompiler-option Pass an option to the compiler."
557 echo " --runtime-option Pass an option to the runtime."
558 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000559 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000560 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700561 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000562 echo " --build-only Build test files only (off by default)."
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100563 echo " --build-with-javac-dx Build test files with javac and dx (on by default)."
564 echo " --build-with-jack Build test files with jack and jill (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000565 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800566 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000567 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000568 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700569 echo " --verify-soft-fail Force soft fail verification (off by default)."
570 echo " Verification is enabled if neither --no-verify"
571 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000572 echo " --no-optimize Turn off optimization (on by default)."
573 echo " --no-precise Turn off precise GC (on by default)."
574 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700575 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000576 echo " other runtime options are ignored."
577 echo " --no-dex2oat Run as though dex2oat was failing."
578 echo " --no-patchoat Run as though patchoat was failing."
579 echo " --prebuild Run dex2oat on the files before starting test. (default)"
580 echo " --no-prebuild Do not run dex2oat on the files before starting"
581 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700582 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000583 echo " --relocate Force the use of relocating in the test, making"
584 echo " the image and oat files be relocated to a random"
585 echo " address before running. (default)"
586 echo " --no-relocate Force the use of no relocating in the test"
Alex Lightfadfee92015-10-28 09:40:10 -0700587 echo " --image Run the test using a precompiled boot image. (default)"
588 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000589 echo " --host Use the host-mode virtual machine."
590 echo " --invoke-with Pass --invoke-with option to runtime."
591 echo " --dalvik Use Dalvik (off by default)."
592 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700593 echo " --use-java-home Use the JAVA_HOME environment variable"
594 echo " to find the java compiler and runtime"
595 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000596 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700597 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000598 echo " --64 Run the test in 64-bit mode"
599 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700600 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700601 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000602 echo " --gcstress Run with gc stress testing"
603 echo " --gcverify Run with gc verification"
604 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700605 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000606 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000607 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700608 echo " --instruction-set-features [string]"
609 echo " Set instruction-set-features for compilation."
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000610 echo " --npic-image Use an image compiled with non-position independent code "
611 echo " for the boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800612 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
613 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700614 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700615 echo " --quiet Don't print anything except failure messages"
616 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700617 exit 1
618fi
619
620cd "$test_dir"
621test_dir=`pwd`
622
623td_info="${test_dir}/${info}"
624td_expected="${test_dir}/${expected}"
625
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700626if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700627 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700628 exit 1
629fi
630
631if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700632 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700633 exit 1
634fi
635
636# copy the test to a temp dir and run it
637
Elliott Hughes510c8782011-10-06 10:57:34 -0700638echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700639
640rm -rf "$tmp_dir"
641cp -Rp "$test_dir" "$tmp_dir"
642cd "$tmp_dir"
643
644if [ '!' -r "$build" ]; then
645 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800646else
647 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700648fi
649
650if [ '!' -r "$run" ]; then
651 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800652else
653 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700654fi
655
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700656if [ '!' -r "$check_cmd" ]; then
657 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800658else
659 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700660fi
661
jeffhao5d1ac922011-09-29 17:41:15 -0700662chmod 755 "$build"
663chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700664chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700665
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700666export TEST_NAME=`basename ${test_dir}`
667
Roland Levillain0d5a2812015-11-13 10:07:31 +0000668# arch_supports_read_barrier ARCH
669# -------------------------------
670# Return whether the Optimizing compiler has read barrier support for ARCH.
671function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000672 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000673 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000674 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000675}
676
David Brazdil4846d132015-01-15 19:07:08 +0000677# Tests named '<number>-checker-*' will also have their CFGs verified with
678# Checker when compiled with Optimizing on host.
679if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000680 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000681 # Optimizing has read barrier support for certain architectures
682 # only. On other architectures, compiling is disabled when read
683 # barriers are enabled, meaning that we do not produce a CFG file
684 # as a side-effect of compilation, thus the Checker assertions
685 # cannot be checked. Disable Checker for those cases.
686 #
687 # TODO: Enable Checker when read barrier support is added to more
688 # architectures (b/12687968).
689 if [ "x$ART_USE_READ_BARRIER" = xtrue ] \
690 && (([ "x$host_mode" = "xyes" ] \
691 && ! arch_supports_read_barrier "$host_arch_name") \
692 || ([ "x$target_mode" = "xyes" ] \
693 && ! arch_supports_read_barrier "$target_arch_name")); then
694 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100695 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
696 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000697 elif [ "$prebuild_mode" = "yes" ] \
698 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100699 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100700
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100701 if [ "$target_mode" = "no" ]; then
702 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100703 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100704 else
705 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100706 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100707 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100708
709 if [ "$debuggable" = "yes" ]; then
710 checker_args="$checker_args --debuggable"
711 fi
712
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100713 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100714 -Xcompiler-option -j1"
715 fi
David Brazdil4846d132015-01-15 19:07:08 +0000716 fi
717fi
718
Mathieu Chartier031768a2015-08-27 10:25:02 -0700719if [ "$runtime" != "jvm" ]; then
720 run_args="${run_args} --testlib ${testlib}"
721fi
722
Ian Rogers997f0f92014-06-21 22:58:05 -0700723# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100724build_file_size_limit=2048
725run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800726
727# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
728# large amounts of expected output or large generated files.
729if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100730 build_file_size_limit=5120
731 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700732fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100733if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
734 # We will need to `adb pull` the .cfg output from the target onto the host to
735 # run checker on it. This file can be big.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000736 build_file_size_limit=24576
737 run_file_size_limit=24576
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100738fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100739if [ ${USE_JACK} = "false" ]; then
740 # Set ulimit if we build with dx only, Jack can generate big temp files.
741 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700742 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100743 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700744fi
745
jeffhao5d1ac922011-09-29 17:41:15 -0700746good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000747good_build="yes"
748good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700749if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000750 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700751 build_exit="$?"
752 echo "build exit status: $build_exit" 1>&2
753 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100754 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700755 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100756 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800757 echo "${test_dir}: running..." 1>&2
758 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700759 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000760
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800761 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000762 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100763 if [ "$target_mode" = "yes" ]; then
764 adb pull $cfg_output_dir/$cfg_output &> /dev/null
765 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100766 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000767 checker_exit="$?"
768 if [ "$checker_exit" = "0" ]; then
769 good="yes"
770 fi
Alex Light91de25f2015-10-28 17:00:06 -0700771 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000772 else
773 good="yes"
774 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800775 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000776 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700777 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700778elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000779 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700780 build_exit="$?"
781 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100782 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700783 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100784 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800785 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700786 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000787 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100788 if [ "$target_mode" = "yes" ]; then
789 adb pull $cfg_output_dir/$cfg_output &> /dev/null
790 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100791 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000792 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700793 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
794 good="yes"
795 else
Alex Light91de25f2015-10-28 17:00:06 -0700796 cat "$build_output" 1>&${real_stderr} 1>&2
797 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700798 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700799elif [ "$build_only" = "yes" ]; then
800 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000801 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700802 build_exit="$?"
803 if [ "$build_exit" '!=' '0' ]; then
804 cp "$build_output" "$output"
805 echo "build exit status: $build_exit" >>"$output"
806 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
807 if [ "$?" '!=' "0" ]; then
808 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700809 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700810 fi
811 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700812 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700813 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700814 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700815else
David Brazdil4846d132015-01-15 19:07:08 +0000816 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700817 build_exit="$?"
818 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100819 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700820 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100821 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800822 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700823 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000824 run_exit="$?"
825 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700826 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000827 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000828 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100829 if [ "$target_mode" = "yes" ]; then
830 adb pull $cfg_output_dir/$cfg_output &> /dev/null
831 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100832 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000833 checker_exit="$?"
834 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700835 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000836 good_run="no"
837 else
838 good_run="yes"
839 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000840 else
841 good_run="yes"
842 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700843 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000844 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700845 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700846 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
847 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700848 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700849 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700850 max_name_length=$(getconf NAME_MAX ${tmp_dir})
851 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
852 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700853 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700854 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700855 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700856 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000857 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
858 # output == expected
859 good="yes"
860 echo "${test_dir}: succeeded!" 1>&2
861 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700862 fi
863fi
864
jeffhao5d1ac922011-09-29 17:41:15 -0700865(
Alex Lightbfac14a2014-07-30 09:41:21 -0700866 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700867 echo "${test_dir}: FAILED!"
868 echo ' '
869 echo '#################### info'
870 cat "${td_info}" | sed 's/^/# /g'
871 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700872 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700873 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700874 if [ "$strace" = "yes" ]; then
875 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700876 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700877 echo '####################'
878 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700879 echo ' '
880 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700881
Alex Light91de25f2015-10-28 17:00:06 -0700882) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700883
884# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700885if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700886 cd "$oldwd"
887 rm -rf "$tmp_dir"
888 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
889 adb shell rm -rf $DEX_LOCATION
890 fi
891 if [ "$good" = "yes" ]; then
892 exit 0
893 fi
894fi
895
896
897(
898 if [ "$always_clean" = "yes" ]; then
899 echo "${TEST_NAME} files deleted from host "
900 if [ "$target_mode" == "yes" ]; then
901 echo "and from target"
902 fi
903 else
904 echo "${TEST_NAME} files left in ${tmp_dir} on host"
905 if [ "$target_mode" == "yes" ]; then
906 echo "and in ${DEX_LOCATION} on target"
907 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700908 fi
909
Alex Light91de25f2015-10-28 17:00:06 -0700910) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700911
Alex Light6a870fa2016-05-31 16:36:19 -0700912if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
913 exit 0
914else
915 exit 1
916fi